// using standard exceptions

#include <iostream>
#include <exception>
using namespace std;

// look at exception class provided by #include (in slides)
class myexception: public exception
{
    public:
        virtual const char * what() const throw() // virtual needed? Effect?
        {
            return "My exception happened";
        }
};


class CustomException1
{
    public:
        int x = 1;
        void func()
        {
            cout << "1 up here" << endl;
        }
};

int main()
{
    try
    {
        throw CustomException1();
    }

    catch (myexception &e)
    {
        cout << "MyException class: " << e.what() << endl;
    }

    catch (exception &e)
    {
        cout << "Exception class: " << e.what() << endl;
    }

    catch (...)
    {
        cout << "Child class? " << endl;
    }
    return 0;
}
