/**
  Try and catch must be in the same scope.
  throw can be in any scope within the try (e.g., in a function called in try)
 **/

#include <iostream>
using namespace std;

double division(int a, int b)
{
    if(b == 0)
    {
        throw "Division by zero condition!";
    }
    return (a / b);
}

int main()
{
    int x = 50;
    int y = 0;
    double z;

    try
    {
        z = division(x, y);
        cout << z << endl; // does this ever happen?
    }

    catch(const char *customErrorMessage)
    {
        cerr << customErrorMessage << endl;
    }
    cout << "hi";

    return 0;
}
