#include <iostream>
using namespace std;

class CustomException1
{
    public:
        int x = 1;
        void func() const
        {
            cout << "1 up here" << endl;
        }
};

class CustomException2
{
    public:
        int x = 2;
        void func() const
        {
            cout << "2 up here" << endl;
        }
};

int main()
{
    try
    {
        throw CustomException2();
    }

    // How do we optimally pass the e?
    // Throw exceptions by value, catch them const by reference
    catch(const CustomException1 &e)
    {
        cerr << e.x << endl;
        e.func();
    }

    catch(const CustomException2 &e)
    {
        cerr << e.x << endl;
        e.func();
    }

    catch(...)
    {
        cerr << "Some other fatal error" << endl;
    }
}

