#include <iostream>
using namespace std;

class CustomException1
{
    public:
        int x = 1;
        void func() const
        {
            cout << "1 up here" << endl;
        }
};

class CustomException2
{
    public:
        int x = 2;
        void func() const
        {
            cout << "2 up here" << endl;
        }
};

int main()
{
    try
    {
        throw CustomException2();
    }

    catch(CustomException1)
    {
        cerr << "Type alone is ok: CustomException1" << endl;
        // Can we access the error object?
    }

    catch(CustomException2)
    {
        cerr << "Type alone is ok: CustomException2" << endl;
    }

    // Catch any unrecognised exceptions (i.e. those which don't derive from std::exception)
    catch(...)
    {
        cerr << "Some fatal error" << endl;
    }
}

